/*
 * AnnualGrouper.java
 *
 * Created on 1  2003 ., 14:26
 */

package com.fn.BikersLog;

import java.util.Calendar;
import java.util.Date;

/**
 *
 * @author  asso
 */
public class AnnualGrouper implements DateGrouper {
    
    Calendar calendar;
    
    public AnnualGrouper() {
        calendar = Calendar.getInstance();
    }
    
    public String getGroupLabel(Date d) {
        calendar.setTime(d);
        return Integer.toString(calendar.get(Calendar.YEAR));
    }
    
    public Date getGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.MONTH, 1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        return calendar.getTime();
    }
    
    public Date getNextGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.MONTH, 1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.YEAR, 1);
        return calendar.getTime();
    }
    
    public Date getPrevGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.MONTH, 1);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.YEAR, -1);
        return calendar.getTime();
    }
    
    public boolean isSameGroup(Date d1, Date d2) {
        calendar.setTime(d1);
        int yearNo = calendar.get(Calendar.YEAR);
        calendar.setTime(d2);
        return (yearNo == calendar.get(Calendar.YEAR));
    }
}
