/*
 * AquaRoute.java
 *
 * Created on 16  2004 ., 12:45
 */

package com.fn.BikersLog;


import org.w3c.dom.Text;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class AquaRoute {
    
    private int id;
    private String name;
    private double length;
    private int refCnt;
    private boolean deleted;
    private double currentSpeed;
    private String notes;
    private int imageId;
    private ImageStorage imageStorage;
    
    /** Creates a new instance of AquaRoute */
    public AquaRoute(ImageStorage is) {
        imageStorage = is;
        imageId = 0;
        name = "";
        length = 0.0;
        id = 0;
        refCnt = 0;
        deleted = false;
        currentSpeed = 0.0;
    }
    
    public AquaRoute(ImageStorage is, Element route) {
        imageStorage = is;
        name = DOMUtil.getSubtagData(route, "name", "");
        length = DOMUtil.getSubtagData(route, "length", 0.0);
        currentSpeed = DOMUtil.getSubtagData(route, "current", 0.0);
        id = DOMUtil.getSubtagData(route, "id", 1);
        deleted = DOMUtil.getSubtagData(route, "deleted", false);
        notes = DOMUtil.getSubtagData(route, "notes", "");
        imageId = DOMUtil.getSubtagData(route, "image", 0);
    }
    
    public void setName(String v) {
        name = v;
    }
    
    public String getName() {
        return name;
    }
    
    public double getLength() {
        return length;
    }

    public void setLength(double length) {
        this.length = length;
    }
    
    public double getCurrentSpeed() {
        return currentSpeed;
    }
    
    public void setCurrentSpeed(double currentSpeed) {
        this.currentSpeed = currentSpeed;
    }    
    
    public String toString() {
        return name;
    }

    public void save(Document document, Element root) {
        if (deleted && (refCnt < 1)) {
            if (0 != imageId)
                imageStorage.removeImage(imageId);
            return;
        }
        Element route = DOMUtil.addElement(document, root, "aquaRoute");
        DOMUtil.addDataElement(document, route, "id", id);
        DOMUtil.addDataElement(document, route, "name", name);
        DOMUtil.addDataElement(document, route, "length", length);
        DOMUtil.addDataElement(document, route, "current", currentSpeed);
        DOMUtil.addDataElement(document, route, "deleted", deleted);
        DOMUtil.addDataElement(document, route, "notes", notes);
        if (0 != imageId)
            DOMUtil.addDataElement(document, route, "image", imageId);
    }
    
    public boolean isDeleted() {
        return deleted;
    }
    
    public void setDeleted(boolean v) {
        deleted = v;
    }
    
    public void addRef() {
        refCnt++;
    }
    
    public void delRef() {
        refCnt--;
    }
    
    public int getId() {
        return id;
    }
    
    public void setId(int v) {
        id = v;
    }
    
    public void setNotes(String v) {
        notes = v;
    }
    
    public String getNotes() {
        return notes;
    }
    
    public int getImage() {
        return imageId;
    }
    
    public void setImage(int image) {
        if (0 != imageId)
            imageStorage.removeImage(imageId);
        this.imageId = image;
    }
    
    public ImageStorage getImageStorage() {
        return imageStorage;
    }
}
