/*
 * Bike.java
 *
 * Created on 12  2003 ., 13:12
 */

package com.fn.BikersLog;


import org.w3c.dom.Text;
import org.w3c.dom.Document;
import org.w3c.dom.Element;


/**
 *
 * @author  asso
 */
public class Bike {
    
    private int id;
    private String name;
    private String description;
    private int type;
    private int refCnt;
    private boolean deleted;
    private int imageId;
    private ImageStorage imageStorage;
    private double weight;
    
    /** Creates a new instance of Bike */
    public Bike(ImageStorage is) {
        id = 0;
        refCnt = 0;
        type = 1;
        deleted = false;
        imageId = 0;
        imageStorage = is;
    }
    
    public Bike(ImageStorage is, Element bike) {
        imageStorage = is;
        refCnt = 0;
        name = DOMUtil.getSubtagData(bike, "name", "");
        description = DOMUtil.getSubtagData(bike, "description", "");
        type = DOMUtil.getSubtagData(bike, "type", 1);
        id = DOMUtil.getSubtagData(bike, "id", 1);
        deleted = DOMUtil.getSubtagData(bike, "deleted", false);
        imageId = DOMUtil.getSubtagData(bike, "image", 0);
        weight = DOMUtil.getSubtagData(bike, "weight", 0.0);
    }
    
    public java.lang.String getName() {
        return name;
    }
    
    public void setName(java.lang.String name) {
        this.name = name;
    }
    
    public java.lang.String getDescription() {
        return description;
    }
    
    public void setDescription(java.lang.String description) {
        this.description = description;
    }

    public String toString() {
        return name;
    }
    
    public int getType() {
        return type;
    }
    
    public void setType(int type) {
        this.type = type;
    }
    
    public void save(Document document, Element root) {
        if (deleted && (refCnt < 1)) {
            if (0 != imageId)
                imageStorage.removeImage(imageId);
            return;
        }
        Element bike = DOMUtil.addElement(document, root, "bike");
        DOMUtil.addDataElement(document, bike, "id", id);
        DOMUtil.addDataElement(document, bike, "name", name);
        DOMUtil.addDataElement(document, bike, "description", description);
        DOMUtil.addDataElement(document, bike, "type", type);
        DOMUtil.addDataElement(document, bike, "deleted", deleted);
        if (0 < imageId)
            DOMUtil.addDataElement(document, bike, "image", imageId);
        DOMUtil.addDataElement(document, bike, "weight", weight);
    }
    
    public boolean isDeleted() {
        return deleted;
    }
    
    public void setDeleted(boolean v) {
        deleted = v;
    }
    
    public void addRef() {
        refCnt++;
    }
    
    public void delRef() {
        refCnt--;
    }
    
    public int getId() {
        return id;
    }
    
    public void setId(int v) {
        id = v;
    }
    
    public int getImage() {
        return imageId;
    }
    
    public void setImage(int image) {
        if (0 != imageId)
            imageStorage.removeImage(imageId);
        this.imageId = image;
    }
    
    public ImageStorage getImageStorage() {
        return imageStorage;
    }
    
    public double getWeight() {
        return weight;
    }
    
    public void setWeight(double weight) {
        this.weight = weight;
    }
}
