/*
 * BoatsListWindow.java
 *
 * Created on 16  2004 ., 11:33
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class BoatsListWindow extends GeneralListWindow {
    
    private Log log;

    /** Creates a new instance of BoatsListWindow */
    public BoatsListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("boatsListForm.title"));
        this.log = log;
        itemsList.setModel(log.getBoatsList());
    }
    
    public static void execute(Frame owner, Log log) {
        BoatsListWindow blw = new BoatsListWindow(owner, log);
        blw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("boatsListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        Boat boat = BoatWindow.addBoat(this, log.getImageStorage());
        if (boat != null) {
            log.getBoatsList().add(boat);
            itemsList.setSelectedIndex(log.getBoatsList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        Boat boat = log.getBoatsList().get(itemNo);
        if (BoatWindow.editBoat(this, boat)) {
            log.getBoatsList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getBoatsList().delete(itemNo);
        log.markAsUnsaved();
    }
}
