/*
 * CalendarView.java
 *
 * Created on 9  2004 ., 10:28
 */

package com.fn.BikersLog;


import java.awt.Container;


/**
 *
 * @author  asso
 */
public class CalendarView extends EventsView 
        implements Config.CalendarOptionsListener {
    
    private Container parent;
    private MonthlyEventsPanel monthlyEventsPanel;
    
    /** Creates a new instance of CalendarView */
    public CalendarView(Log log) {
        super(log);
        monthlyEventsPanel = new MonthlyEventsPanel(log.getEventsList());
    }
    
    public Event getSelected(boolean edit) {
        EventsInDay events = monthlyEventsPanel.getSelected();
        if ((null == events) || (0 == events.getSize()))
            return null;
        if (1 == events.getSize())
            return (Event)events.getElementAt(0);
        else
            return DailyEventChooser.execute(MainWindow.getInstance(), edit, 
                events);
    }
    
    public void install(Container parent) {
        this.parent = parent;
        parent.add(monthlyEventsPanel);
        monthlyEventsPanel.setVisible(true);
        Config.setCalendarOptionsListener(this);
        monthlyEventsPanel.startMonitoring();
        monthlyEventsPanel.focusTable();
    }
    
    public void remove() {
        parent.remove(monthlyEventsPanel);
        Config.setCalendarOptionsListener(null);
        monthlyEventsPanel.stopMonitoring();
    }
    
    public void saveOptions() {
    }
    
    public void setSelectedIndex(int index) {
    }
    
    public void onOptionsChanged() {
        monthlyEventsPanel.updateView();
    }
    
    public void setLog(Log log) {
        super.setLog(log);
        monthlyEventsPanel.setEventsList(log.getEventsList());
    }
    
    public java.util.Date getNewEventDate() {
        return monthlyEventsPanel.getSelectedDate();
    }
    
}
