/*
 * ComboListAdapter.java
 *
 * Created on 13  2003 ., 22:27
 */

package com.fn.BikersLog;


import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.ListModel;


/**
 *
 * @author  asso
 */
public class ComboListAdapter implements javax.swing.ComboBoxModel {
    
    private Object selectedItem = null;
    private ListModel listModel;
    private List dataListeners = new LinkedList();
    private Object addonItem;
    
    public ComboListAdapter(ListModel listModel) {
        this.listModel = listModel;
        addonItem = null;
        if (listModel.getSize() > 0)
            setSelectedItem(listModel.getElementAt(0));
    }
    
    public void setAddonItem(Object item) {
        addonItem = item;
    }
    
    public void addListDataListener(ListDataListener l) {
        dataListeners.add(l);
        listModel.addListDataListener(l);
    }
    
    public Object getElementAt(int index) {
        if (addonItem == null)
            return listModel.getElementAt(index);
        else
            if (index == 0)
                return addonItem;
            else
                return listModel.getElementAt(index - 1);
    }
    
    public Object getSelectedItem() {
        return selectedItem;
    }
    
    public int getSize() {
        if (addonItem == null)
          return listModel.getSize();
        else
          return listModel.getSize() + 1;
    }
    
    public void removeListDataListener(ListDataListener l) {
        dataListeners.remove(l);
        listModel.removeListDataListener(l);
    }
    
    public void setSelectedItem(Object anItem) {
        selectedItem = anItem;
        ListDataEvent ev = new ListDataEvent(this, ListDataEvent.CONTENTS_CHANGED, 
                0, getSize() - 1);
        for (Iterator i = dataListeners.iterator(); i.hasNext(); ) {
            ((ListDataListener)i.next()).contentsChanged(ev);
        }
    }
    
}
