/*
 * CyclotrainerWindow.java
 *
 * Created on 2  2004 ., 11:50
 */

package com.fn.BikersLog;


import java.text.DateFormat;
import java.util.Date;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class CyclotrainerWindow extends javax.swing.JDialog {
    
    private CycleTrainerEvent trainerEvent;
    private DateFormat dateFormat;
    private boolean okPressed = false;
    
    /** Creates new form CyclotrainerWindow */
    public CyclotrainerWindow(java.awt.Frame parent, CycleTrainerEvent e, boolean editing) {
        super(parent, true);
        trainerEvent = e;
        dateFormat = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT);
        dateFormat.setLenient(false);
        initComponents();
        if (editing)
            setTitle(I18n.getMsg("cyclotrainerForm.editTitle"));
        else
            setTitle(I18n.getMsg("cyclotrainerForm.addTitle"));
        setValues();
        Utils.centerWindow(this, parent);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        okBtn = new javax.swing.JButton();
        cancelBtn = new javax.swing.JButton();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        startCalendar = new org.rapla.components.calendar.RaplaCalendar();
        startTime = new org.rapla.components.calendar.RaplaTime();
        jLabel2 = new javax.swing.JLabel();
        finishCalendar = new org.rapla.components.calendar.RaplaCalendar();
        finishTime = new org.rapla.components.calendar.RaplaTime();
        jLabel3 = new javax.swing.JLabel();
        heartRateField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        effortField = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        wattageTextField = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        weightTextField = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        caloriesTextField = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okBtn.setText(I18n.getMsg("generic.ok"));
        okBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okBtnActionPerformed(evt);
            }
        });

        jPanel1.add(okBtn);

        cancelBtn.setText(I18n.getMsg("generic.cancel"));
        cancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelBtnActionPerformed(evt);
            }
        });

        jPanel1.add(cancelBtn);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jTabbedPane1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)));
        jPanel2.setLayout(new java.awt.GridBagLayout());

        jLabel1.setText(I18n.getMsg("cyclotrainerForm.propsTab.start"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 4, 4);
        jPanel2.add(jLabel1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 0.5;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 4, 4);
        jPanel2.add(startCalendar, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 4, 4);
        gridBagConstraints.weightx = 0.5;
        jPanel2.add(startTime, gridBagConstraints);

        jLabel2.setText(I18n.getMsg("cyclotrainerForm.propsTab.finish"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(finishCalendar, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(finishTime, gridBagConstraints);

        jLabel3.setLabelFor(heartRateField);
        jLabel3.setText(I18n.getMsg("cyclotrainerForm.propsTab.heartRate"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(heartRateField, gridBagConstraints);

        jLabel4.setLabelFor(effortField);
        jLabel4.setText(I18n.getMsg("cyclotrainerForm.propsTab.effort"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(effortField, gridBagConstraints);

        jLabel5.setText(I18n.getMsg("rideForm.results.wattage"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel5, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(wattageTextField, gridBagConstraints);

        jLabel6.setText(I18n.getMsg("rideForm.results.weight"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 4, 4);
        jPanel2.add(jLabel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 4);
        jPanel2.add(weightTextField, gridBagConstraints);

        jLabel7.setText(I18n.getMsg("rideForm.results.calories"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 8, 8, 4);
        jPanel2.add(jLabel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 8, 4);
        jPanel2.add(caloriesTextField, gridBagConstraints);

        jLabel8.setText(Units.getWeight().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 8);
        jPanel2.add(jLabel8, gridBagConstraints);

        jTabbedPane1.addTab(I18n.getMsg("cyclotrainerForm.propsTab.title"), jPanel2);

        jPanel3.setLayout(new java.awt.BorderLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel3.setPreferredSize(new java.awt.Dimension(380, 200));
        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 200));
        notesTextArea.setLineWrap(true);
        jScrollPane1.setViewportView(notesTextArea);

        jPanel3.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab(I18n.getMsg("cyclotrainerForm.notesTab.title"), jPanel3);

        getContentPane().add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelBtnActionPerformed
        okPressed = false;
        setVisible(false);
    }//GEN-LAST:event_cancelBtnActionPerformed

    private void okBtnActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okBtnActionPerformed
        try {
            getValues();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(this, e.getMessage(),
                    I18n.getMsg("mainWindow.title"), JOptionPane.ERROR_MESSAGE);
            return;
        }
        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okBtnActionPerformed

    private void setValues() {
        startCalendar.setDate(trainerEvent.getStart());
        startTime.setTime(trainerEvent.getStart());
        finishCalendar.setDate(trainerEvent.getFinish());
        finishTime.setTime(trainerEvent.getFinish());
        heartRateField.setText(Integer.toString(trainerEvent.getHeartRate()));
        effortField.setText(Integer.toString(trainerEvent.getEffort()));
        notesTextArea.setText(trainerEvent.getNotes());
        weightTextField.setText(Utils.doubleToStr(
                Units.fromStdWeight(trainerEvent.getWeight())));
        caloriesTextField.setText(Utils.doubleToStr(trainerEvent.getCalories()));
        wattageTextField.setText(Utils.doubleToStr(trainerEvent.getWattage()));
    }
    
    private void getValues() throws Exception {
        int heartRate = Utils.parseInt(heartRateField.getText(), "rideForm.invalidHR");
        int effort = Utils.parseInt(effortField.getText(), "cyclotrainerForm.invalidEffort");
        double weight = Utils.parseDouble(weightTextField.getText(), 
                    "generic.invalidWeight");
        double calories = Utils.parseDouble(caloriesTextField.getText(), 
                    "rideForm.invalidCalories");
        double wattage = Utils.parseDouble(wattageTextField.getText(), 
                    "rideForm.invalidWattage");
        
        trainerEvent.setStart(Utils.calendarToDateTime(startCalendar, startTime));
        trainerEvent.setFinish(Utils.calendarToDateTime(finishCalendar, finishTime));
        trainerEvent.setHeartRate(heartRate);
        trainerEvent.setNotes(notesTextArea.getText());
        trainerEvent.setEffort(effort);
        trainerEvent.setWeight(Units.toStdWeight(weight));
        trainerEvent.setCalories(calories);
        trainerEvent.setWattage(wattage);
    }
        
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
    }//GEN-LAST:event_closeDialog
    
    public static CycleTrainerEvent addTraining(java.awt.Frame owner, Date start) {
        CycleTrainerEvent event = new CycleTrainerEvent();
        event.setStart(start);
        event.setFinish(start);
        CyclotrainerWindow ctw = new CyclotrainerWindow(owner, event, false);
        ctw.setVisible(true);
        ctw.dispose();
        return ctw.okPressed ? event : null;
    }
    
    public static boolean editTraining(java.awt.Frame owner, CycleTrainerEvent event) {
        CyclotrainerWindow ctw = new CyclotrainerWindow(owner, event, true);
        ctw.setVisible(true);
        ctw.dispose();
        return ctw.okPressed;
    }
            
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField caloriesTextField;
    private javax.swing.JButton cancelBtn;
    private javax.swing.JTextField effortField;
    private org.rapla.components.calendar.RaplaCalendar finishCalendar;
    private org.rapla.components.calendar.RaplaTime finishTime;
    private javax.swing.JTextField heartRateField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JButton okBtn;
    private org.rapla.components.calendar.RaplaCalendar startCalendar;
    private org.rapla.components.calendar.RaplaTime startTime;
    private javax.swing.JTextField wattageTextField;
    private javax.swing.JTextField weightTextField;
    // End of variables declaration//GEN-END:variables
    
}
