/*
 * EventsDataSet.java
 *
 * Created on 18  2004 ., 13:32
 */

package com.fn.BikersLog;


import java.util.Date;
import com.fn.repway.DataSet;
import com.fn.repway.RepException;


/**
 *
 * @author  asso
 */
public abstract class EventsDataSet implements DataSet {
    
    private String name;
    private EventsList eventsList;
    private int size;
    private int position, index;
    protected Event event;
    private long fromTime, toTime;
    
    /** Creates a new instance of EventsDataSet */
    public EventsDataSet(String name, EventsList el, Date from, Date to) {
        this.name = name;
        eventsList = el;
        fromTime = from.getTime();
        toTime = to.getTime() + 60*60*24 * 1000;
        size = 0;
        int sz = eventsList.getSize();
        for (int i = 0; i < sz; i++) {
            Event ev = eventsList.get(i);
            long time = ev.getStart().getTime();
            if (isSuitableEvent(ev) && (time >= fromTime) && (time <= toTime))
                size++;
        }
        reset();
    }
    
    protected abstract boolean isSuitableEvent(Event event);
    
    public String getName() {
        return name;
    }
    
    public boolean gotoNext() {
        index--;
        while (index >= 0) {
            Event e = eventsList.get(index);
            long time = e.getStart().getTime();
            if (isSuitableEvent(e) && (time >= fromTime) && (time <= toTime)) {
                position++;
                event = e;
                return true;
            }
            index--;
        }
        return false;
    }
    
    public boolean hasNext() throws RepException {
        return (position < size-1) && (size > 0);
    }
    
    public boolean hasCurrent() throws RepException {
        return (position < size) && (size > 0);
    }
    
    public void reset() {
        position = -1;
        index = eventsList.getSize();
        try { gotoNext(); } catch (Exception e) { }
    }
}
