/*
 * MonthlyGrouper.java
 *
 * Created on 1  2003 ., 14:08
 */

package com.fn.BikersLog;


import java.util.Calendar;
import java.util.Date;
import java.text.SimpleDateFormat;


/**
 *
 * @author  asso
 */
public class MonthlyGrouper implements DateGrouper {
    
    SimpleDateFormat dateFormat;
    Calendar calendar;
    
    /** Creates a new instance of MonthlyGrouper */
    public MonthlyGrouper() {
        calendar = Calendar.getInstance();
        dateFormat = new SimpleDateFormat("MMMMM");
    }
    
    public String getGroupLabel(Date d) {
        calendar.setTime(d);
        return dateFormat.format(calendar.getTime());
    }
    
    public Date getGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        return calendar.getTime();
    }
    
    public Date getNextGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.MONTH, 1);
        return calendar.getTime();
    }
    
    public Date getPrevGroupStart(Date d) {
        calendar.setTime(d);
        calendar.set(Calendar.DAY_OF_MONTH, 1);
        calendar.add(Calendar.MONTH, -1);
        return calendar.getTime();
    }
    
    public boolean isSameGroup(Date d1, Date d2) {
        calendar.setTime(d1);
        int monthNo = calendar.get(Calendar.MONTH);
        int yearNo = calendar.get(Calendar.YEAR);
        calendar.setTime(d2);
        return ((monthNo == calendar.get(Calendar.MONTH)) 
                && (yearNo == calendar.get(Calendar.YEAR)));
    }
    
}
