/*
 * NoteEvent.java
 *
 * Created on 1  2003 ., 18:34
 */

package com.fn.BikersLog;


import java.text.DateFormat;
import java.util.Date;
import javax.swing.ImageIcon;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Text;


/**
 *
 * @author  asso
 */
public class NoteEvent extends Event {

    private String text;
    private String displayText;
    private static ImageIcon icon = null;
    private static String noteType = I18n.getMsg("note.type");
    
    /** Creates a new instance of NoteEvent */
    public NoteEvent() {
        text = "";
        setDisplayText();
    }
    
    public NoteEvent(Element note, Log log) {
        setStart(DOMUtil.getSubtagData(note, "start", new Date()));
        text = DOMUtil.getSubtagData(note, "text", "");
        setDisplayText();
    }
    
    public void save(Document document, Element parent) {
        Element note = DOMUtil.addElement(document, parent, "event");
        DOMUtil.addDataElement(document, note, "type", "note");
        DOMUtil.addDataElement(document, note, "start", getStart());
        DOMUtil.addDataElement(document, note, "text", text);
    }
    
    public String getText() {
        return text;
    }
    
    public void setText(String text) {
        this.text = text;
        setDisplayText();
    }
    
    public void setDisplayText() {
        DateFormat df = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.SHORT);
        StringBuffer sb = new StringBuffer();
        sb.append(df.format(getStart())).append(' ').append(I18n.getMsg("note.type"));
        sb.append(' ').append(text.replace((char)10, ' '));
        displayText = sb.toString();
    }
    
    public String toString() {
        return displayText;
    }
    
    public ImageIcon getIcon() {
        if (null == icon)
            icon = new ImageIcon(getClass().getResource("/com/fn/BikersLog/img/note.png"));
        return icon;
    }
    
    public Object getColumnData(int column) {
        if (Event.COLUMN_NOTES == column)
            return displayText;
        else if (Event.COLUMN_TYPE == column)
            return noteType;
        else
            return super.getColumnData(column);
    }
    
}
