/*
 * NoteWindow.java
 *
 * Created on 1  2003 ., 18:46
 */

package com.fn.BikersLog;


import java.util.Calendar;
import java.util.Date;;


/**
 *
 * @author  asso
 */
public class NoteWindow extends javax.swing.JDialog {
    
    private NoteEvent noteEvent;
    private boolean okPressed = false;
    
    /** Creates new form NoteWindow */
    public NoteWindow(java.awt.Frame parent, NoteEvent ne, boolean editing) {
        super(parent, true);
        noteEvent = ne;
        if (editing)
            setTitle(I18n.getMsg("noteForm.editTitle"));
        else
            setTitle(I18n.getMsg("noteForm.addTitle"));
        initComponents();
        noteTextArea.setText(noteEvent.getText());
        Utils.centerWindow(this, parent);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        dateCalendar = new org.rapla.components.calendar.RaplaCalendar();
        dateTime = new org.rapla.components.calendar.RaplaTime();
        jScrollPane1 = new javax.swing.JScrollPane();
        noteTextArea = new javax.swing.JTextArea();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel1.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel1.add(cancelButton);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.CompoundBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)), new javax.swing.border.TitledBorder(I18n.getMsg("noteForm.frameTitle"))));
        jLabel1.setText(I18n.getMsg("noteForm.date"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 0, 8);
        jPanel2.add(jLabel1, gridBagConstraints);

        dateCalendar.setDate(noteEvent.getStart());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(8, 4, 0, 4);
        jPanel2.add(dateCalendar, gridBagConstraints);

        dateTime.setTime(noteEvent.getStart());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 8);
        jPanel2.add(dateTime, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(400, 280));
        noteTextArea.setLineWrap(true);
        noteTextArea.setWrapStyleWord(true);
        jScrollPane1.setViewportView(noteTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(8, 8, 8, 8);
        jPanel2.add(jScrollPane1, gridBagConstraints);

        getContentPane().add(jPanel2, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        noteEvent.setStart(Utils.calendarToDateTime(dateCalendar, dateTime));
        noteEvent.setText(noteTextArea.getText());
        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
    }//GEN-LAST:event_closeDialog
    
    public static NoteEvent addNote(java.awt.Frame owner, Date start) {
        NoteEvent event = new NoteEvent();
        event.setStart(start);
        NoteWindow nw = new NoteWindow(owner, event, false);
        nw.setVisible(true);
        nw.dispose();
        return nw.okPressed ? event : null;
    }
    
    public static boolean editNote(java.awt.Frame owner, NoteEvent event) {
        NoteWindow nw = new NoteWindow(owner, event, true);
        nw.setVisible(true);
        nw.dispose();
        return nw.okPressed;
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel jLabel1;
    private org.rapla.components.calendar.RaplaTime dateTime;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JTextArea noteTextArea;
    private javax.swing.JButton okButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JPanel jPanel1;
    private org.rapla.components.calendar.RaplaCalendar dateCalendar;
    // End of variables declaration//GEN-END:variables
    
}
