/*
 * OffsetInputStream.java
 *
 * Created on 25  2004 ., 11:47
 */

package com.fn.BikersLog;


import java.io.RandomAccessFile;


/**
 *
 * @author  asso
 */
public class OffsetInputStream extends java.io.InputStream {
    
    private RandomAccessFile file;
    private long offset;
    private long size;
    private long pos;
    private long marked;
    
    /** Creates a new instance of OffsetInputStream */
    public OffsetInputStream(RandomAccessFile f, long off, long sz) {
        file = f;
        offset = off;
        size = sz;
        pos = 0;
        marked = 0;
    }
    
    public int read() throws java.io.IOException {
        if (pos >= size)
            return -1;
        else {
            file.seek(offset + pos);
            int b = file.readByte();
            if (b < 0) b += 256;
            pos++;
            return b;
        }
    }
    
    public long skip(long n) throws java.io.IOException {
        if (n > size)
            n = size - pos;
        pos += n;
        return n;
    }
    
    public int available() {
        return (int)(size - pos);
    }
    
    public boolean markSupported() {
        return true;
    }
    
    public void mark(int readlimit) {
        marked = pos;
    }
    
    public int read(byte[] b, int off, int len) throws java.io.IOException {
        if (0 == len)
            return 0;
        if (0 > len)
            return -1;
        if (pos + len > size)
            len = (int)(size - pos);
        if (0 >= len)
            return -1;
        file.seek(offset + pos);
        int c = file.read(b, off, len);
        if (c > 0)
            pos += c;
        return c;
    }
    
    public void reset() throws java.io.IOException {
        pos = marked;
    }
    
}
