/*
 * CourseForm.java
 *
 * Created on 27  2003 ., 13:04
 */

package com.fn.BikersLog;


import java.awt.image.BufferedImage;
import java.io.File;
import java.text.NumberFormat;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;


/**
 *
 * @author  asso
 */
public class RunRouteWindow extends javax.swing.JDialog {
    
    private RunRoute route;
    private boolean okPressed = false;
    private HeightProfile heightProfile;
    
    /** Creates new form CourseForm */
    public RunRouteWindow(java.awt.Dialog owner, RunRoute route, boolean edit) {
        super(owner, true);
        this.route = route;
        heightProfile = new HeightProfile(route.getHeightsProfile());
        initComponents();
        if (edit)
            setTitle(I18n.getMsg("runRouteForm.editTitle"));
        else
            setTitle(I18n.getMsg("runRouteForm.newTitle"));
        
        nameTextField.setText(route.getName());
        double length;
        if (heightProfile.isEmpty())
            length = route.getLength();
        else {
            length = heightProfile.getLength();
            lengthTextField.setEnabled(false);
        }
        lengthTextField.setText(Utils.doubleToStr(Units.fromStdBDist(length)));
        notesTextArea.setText(route.getNotes());
        
        Utils.centerWindow(this, owner);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        jTabbedPane1 = new javax.swing.JTabbedPane();
        jPanel3 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        nameTextField = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        lengthTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        notesTextArea = new javax.swing.JTextArea();
        jLabel3 = new javax.swing.JLabel();
        imageEditor = new ImageEditor(route.getImage(), route.getImageStorage());
        jPanel5 = new javax.swing.JPanel();
        heightProfileEditor = new HeightProfileEditor(heightProfile);
        jPanel2 = new javax.swing.JPanel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel1.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 0, 8)));
        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel3.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentShown(java.awt.event.ComponentEvent evt) {
                jPanel3ComponentShown(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel1.setLabelFor(nameTextField);
        jLabel1.setText(I18n.getMsg("courseForm.name"));
        jLabel1.setMaximumSize(new java.awt.Dimension(330, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 4, 4);
        jPanel3.add(jLabel1, gridBagConstraints);

        nameTextField.setPreferredSize(new java.awt.Dimension(180, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(0, 4, 4, 0);
        jPanel3.add(nameTextField, gridBagConstraints);

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        jLabel2.setLabelFor(lengthTextField);
        jLabel2.setText(I18n.getMsg("courseForm.length"));
        jLabel2.setMaximumSize(new java.awt.Dimension(400, 16));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 4);
        jPanel3.add(jLabel2, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        jPanel3.add(lengthTextField, gridBagConstraints);

        jLabel4.setText(I18n.getMsg("courseForm.notes"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 0, 4);
        jPanel3.add(jLabel4, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(330, 200));
        jScrollPane1.setRequestFocusEnabled(false);
        notesTextArea.setLineWrap(true);
        notesTextArea.setWrapStyleWord(true);
        jScrollPane1.setViewportView(notesTextArea);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 0, 0);
        jPanel3.add(jScrollPane1, gridBagConstraints);

        jLabel3.setText(Units.getBDist().getShortName());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(4, 4, 4, 0);
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(jLabel3, gridBagConstraints);

        jTabbedPane1.addTab(I18n.getMsg("courseForm.route.title"), jPanel3);

        imageEditor.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jTabbedPane1.addTab(I18n.getMsg("courseForm.picture.title"), imageEditor);

        jPanel5.setLayout(new java.awt.BorderLayout());

        jPanel5.setBorder(new javax.swing.border.EmptyBorder(new java.awt.Insets(8, 8, 8, 8)));
        jPanel5.add(heightProfileEditor, java.awt.BorderLayout.CENTER);

        jTabbedPane1.addTab(I18n.getMsg("courseForm.profile.title"), jPanel5);

        jPanel1.add(jTabbedPane1, java.awt.BorderLayout.CENTER);

        getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.CENTER, 8, 8));

        okButton.setText(I18n.getMsg("generic.ok"));
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        jPanel2.add(okButton);

        cancelButton.setText(I18n.getMsg("generic.cancel"));
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jPanel2.add(cancelButton);

        getContentPane().add(jPanel2, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void jPanel3ComponentShown(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_jPanel3ComponentShown
        if (! heightProfile.isEmpty()) {
            lengthTextField.setEnabled(false);
            double l = Units.fromStdBDist(heightProfile.getLength());
            lengthTextField.setText(Utils.doubleToStr(l));
        } else
            lengthTextField.setEnabled(true);
    }//GEN-LAST:event_jPanel3ComponentShown

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        okPressed = false;
        setVisible(false);
    }//GEN-LAST:event_cancelButtonActionPerformed

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        double distance = -1;
        
        if (heightProfile.isEmpty()) {
            try {
                distance = NumberFormat.getInstance().parse(lengthTextField.
                        getText()).doubleValue();
            } catch (Exception e) { }

            if (distance <= 0.0) {
                JOptionPane.showMessageDialog(this, I18n.getMsg("courseForm.invalidLength"), 
                    I18n.getMsg("mainForm.title"), 
                    javax.swing.JOptionPane.ERROR_MESSAGE);
                return;
            }
        } else
            distance = heightProfile.getLength();

        String name = nameTextField.getText();
        if (name.length() < 1) {
            JOptionPane.showMessageDialog(this, I18n.getMsg("courseForm.invalidName"), 
                I18n.getMsg("mainForm.title"), 
                javax.swing.JOptionPane.ERROR_MESSAGE);
            return;
        }

        route.setName(name);
        route.setLength(Units.toStdBDist(distance));
        route.setNotes(notesTextArea.getText());
        if (imageEditor.isImageChanged())
            route.setImage(imageEditor.saveImage());
        route.setHeightsProfile(heightProfileEditor.getHeightProfile());

        okPressed = true;
        setVisible(false);
    }//GEN-LAST:event_okButtonActionPerformed
    
    public static boolean edit(java.awt.Dialog owner, RunRoute route) {
        RunRouteWindow cw = new RunRouteWindow(owner, route, true);
        cw.setVisible(true);
        cw.dispose();
        return cw.okPressed;
    }
    
    public static RunRoute add(java.awt.Dialog owner, ImageStorage is) {
        RunRouteWindow cw = new RunRouteWindow(owner, new RunRoute(is), false);
        cw.setVisible(true);
        cw.dispose();
        if (cw.okPressed)
            return cw.route;
        else
            return null;
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private com.fn.BikersLog.HeightProfileEditor heightProfileEditor;
    private com.fn.BikersLog.ImageEditor imageEditor;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTabbedPane jTabbedPane1;
    private javax.swing.JTextField lengthTextField;
    private javax.swing.JTextField nameTextField;
    private javax.swing.JTextArea notesTextArea;
    private javax.swing.JButton okButton;
    // End of variables declaration//GEN-END:variables
    
}
