/*
 * BikeRoutesListWindow.java
 *
 * Created on 5  2004 ., 12:50
 */

package com.fn.BikersLog;


import java.awt.Frame;


/**
 *
 * @author  asso
 */
public class RunRoutesListWindow extends GeneralListWindow {
    
    private Log log;
    
    /** Creates a new instance of BikeRoutesListWindow */
    public RunRoutesListWindow(Frame owner, Log log) {
        super(owner, I18n.getMsg("runRoutesListForm.title"));
        this.log = log;
        itemsList.setModel(log.getRunRoutesList());
    }
    
    public static void execute(Frame owner, Log log) {
        RunRoutesListWindow rrw = new RunRoutesListWindow(owner, log);
        rrw.setVisible(true);
    }
    
    /** This method is called when delete confirmation window needs message */
    protected String getDelPrompt(javax.swing.ListModel model, int itemNo) {
        return I18n.getMsg("runRoutesListForm.areYouSure");
    }
    
    /** This method is called when add button pressed */
    protected void onAdd(javax.swing.ListModel model) {
        RunRoute route = RunRouteWindow.add(this, log.getImageStorage());
        if (null != route) {
            log.getRunRoutesList().add(route);
            itemsList.setSelectedIndex(log.getRunRoutesList().getSize() - 1);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when edit button pressed */
    protected void onEdit(javax.swing.ListModel model, int itemNo) {
        RunRoute route = log.getRunRoutesList().get(itemNo);
        if (RunRouteWindow.edit(this, route)) {
            log.getRunRoutesList().change(itemNo);
            log.markAsUnsaved();
        }
    }
    
    /** This method is called when delete button pressed */
    protected void onDelete(javax.swing.ListModel model, int itemNo) {
        log.getRunRoutesList().delete(itemNo);
        log.markAsUnsaved();
    }
    
}
