/*
 * RidesDataSet.java
 *
 * Created on 31  2003 ., 23:47
 */

package com.fn.BikersLog;


import java.util.Date;
import com.fn.repway.RepException;
import com.fn.repway.Value;


/**
 *
 * @author  asso
 */
public class SwimmingDataSet extends EventsDataSet {
    
    /** Creates a new instance of RidesDataSet */
    public SwimmingDataSet(EventsList el, Date from, Date to) {
        super("events", el, from, to);
    }
    
    public Value getValue(String name) throws RepException {
        SwimmingEvent event = (SwimmingEvent)this.event;
        if (name.equals("finish"))
            return new Value(Value.TIME, event.getFinish());
        else if (name.equals("date"))
            return new Value(Value.DATE, event.getStart());
        else if (name.equals("elapsed"))
            return new Value(Value.TIMEINT, event.getElapsed());
        else if (name.equals("distance"))
            return new Value(Units.fromStdBDist(event.getDistance()));
        else if (name.equals("speed"))
            return new Value(Units.fromStdSpeed(event.getAvgSpeed()));
        else if (name.equals("hr"))
            return new Value(event.getHeartRate());
        else if (name.equals("style"))
            return new Value(event.getStyleName(event.getStyle()));
        throw new RepException("Unknown field '" + name + "'");
    }
    
    protected boolean isSuitableEvent(Event event) {
        return event instanceof SwimmingEvent;
    }
    
}
