/*
 * WeeklyGrouper.java
 *
 * Created on 27  2003 ., 15:24
 */

package com.fn.BikersLog;


import java.text.DateFormat;
import java.util.Calendar;
import java.util.Date;


/**
 *
 * @author  asso
 */
public class WeeklyGrouper implements DateGrouper {
    
    DateFormat dateFormat;
    Calendar calendar;
    
    /** Creates a new instance of WeeklyGrouper */
    public WeeklyGrouper() {
        calendar = Calendar.getInstance();
        dateFormat = DateFormat.getDateInstance(DateFormat.SHORT);
    }
    
    public String getGroupLabel(Date d) {
        calendar.setTime(d);
        while (calendar.get(Calendar.DAY_OF_WEEK) != calendar.getFirstDayOfWeek())
            calendar.add(Calendar.DATE, -1);
        return dateFormat.format(calendar.getTime());
    }
    
    public boolean isSameGroup(Date d1, Date d2) {
        calendar.setTime(d1);
        int weekNo = calendar.get(Calendar.WEEK_OF_YEAR);
        calendar.setTime(d2);
        return (weekNo == calendar.get(Calendar.WEEK_OF_YEAR));
    }
    
    public Date getNextGroupStart(Date d) {
        calendar.setTime(d);
        while (calendar.get(Calendar.DAY_OF_WEEK) != calendar.getFirstDayOfWeek())
            calendar.add(Calendar.DATE, -1);
        calendar.add(Calendar.DATE, 7);
        return calendar.getTime();
    }
    
    public Date getPrevGroupStart(Date d) {
        calendar.setTime(d);
        while (calendar.get(Calendar.DAY_OF_WEEK) != calendar.getFirstDayOfWeek())
            calendar.add(Calendar.DATE, -1);
        calendar.add(Calendar.DATE, -7);
        return calendar.getTime();
    }
    
    public Date getGroupStart(Date d) {
        calendar.setTime(d);
        while (calendar.get(Calendar.DAY_OF_WEEK) != calendar.getFirstDayOfWeek())
            calendar.add(Calendar.DATE, -1);
        return calendar.getTime();
    }
    
}
