/*
 * PreferencesTree.java
 *
 * Created on 8  2004 ., 13:38
 */

package com.fn.BikersLog.prefs;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;


/**
 *
 * @author  asso
 */
public class PreferencesTree implements TreeModel {
    
    private List listeners;
    private Map nodesByPage;
    private Map nodesByIdent;
    private Node root;
    
    private class Node {
        private PrefsPageCreator page;
        private List childs;
        
        public Node(PrefsPageCreator creator) {
            page = creator;
        }
    }
    
    /** Creates a new instance of PreferencesTree */
    public PreferencesTree() {
        nodesByPage = new HashMap();
        nodesByIdent = new HashMap();
        root = new Node(new PrefsPageCreator("root", "prefsTree.root", 
                EmptyPane.class));
        nodesByIdent.put("root", root);
        nodesByPage.put(root.page, root);
    }
    
    public void addTreeModelListener(TreeModelListener l) {
        if (null == listeners)
            listeners = new LinkedList();
        listeners.add(l);
    }
    
    public Object getChild(Object parent, int index) {
        Node node = (Node)nodesByPage.get(parent);
        if ((null == node) || (null == node.childs))
            return null;
        return  ((Node)node.childs.get(index)).page;
    }
    
    public int getChildCount(Object parent) {
        Node node = (Node)nodesByPage.get(parent);
        if ((null == node) || (null == node.childs))
            return 0;
        return node.childs.size();
    }
    
    public int getIndexOfChild(Object parent, Object child) {
        Node node = (Node)nodesByPage.get(parent);
        if ((null == node) || (null == node.childs))
            return -1;
        int j = 0;
        for (Iterator i = node.childs.iterator(); i.hasNext(); j++) {
            Node n = (Node)i.next();
            if (n.page == child)
                return j;
        }
        return -1;
    }
    
    public Object getRoot() {
        return root.page;
    }
    
    public boolean isLeaf(Object n) {
        Node node = (Node)nodesByPage.get(n);
        return (null == node) || (null == node.childs) || 
                (0 == node.childs.size());
    }
    
    public void removeTreeModelListener(TreeModelListener l) {
        if (null != listeners)
            listeners.remove(l);
    }
    
    public void valueForPathChanged(TreePath path, Object newValue) {
    }
    
    public void addPage(String parent, String ident, String descr, 
            Class pageClass)
    {
        PrefsPageCreator page = new PrefsPageCreator(ident, descr, pageClass);
        Node node = new Node(page);
        Node parentNode = (Node)nodesByIdent.get(parent);
        if (null == parentNode)
            return;
        if (null == parentNode.childs)
            parentNode.childs = new ArrayList();
        parentNode.childs.add(node);
        nodesByIdent.put(ident, node);
        nodesByPage.put(page, node);
    }
}
