/*
 * TableViewPane.java
 *
 * Created on 11  2004 ., 11:35
 */

package com.fn.BikersLog.prefs;


import com.fn.BikersLog.Config;
import com.fn.BikersLog.I18n;


/**
 *
 * @author  asso
 */
public class TableViewPane extends javax.swing.JPanel implements PreferencesPage {
    
    /** Creates new form TableViewPane */
    public TableViewPane() {
        initComponents();
        tableEventTimeCheckBox.setSelected(Config.getTableShowStartTime());
        tableEventDateCheckBox.setSelected(Config.getTableShowFinishDate());
        tableScrollCheckBox.setSelected(Config.getTableShowScroll());
   }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        tableEventTimeCheckBox = new javax.swing.JCheckBox();
        tableEventDateCheckBox = new javax.swing.JCheckBox();
        tableScrollCheckBox = new javax.swing.JCheckBox();

        setLayout(new java.awt.GridBagLayout());

        tableEventTimeCheckBox.setText(I18n.getMsg("preferencesForm.tableView.showTime"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(tableEventTimeCheckBox, gridBagConstraints);

        tableEventDateCheckBox.setText(I18n.getMsg("preferencesForm.tableView.showFinishDate"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(tableEventDateCheckBox, gridBagConstraints);

        tableScrollCheckBox.setText(I18n.getMsg("preferencesForm.tableView.enableScroll"));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        add(tableScrollCheckBox, gridBagConstraints);

    }//GEN-END:initComponents

    public void apply() {
        Config.setTableShowStartTime(tableEventTimeCheckBox.isSelected());
        Config.setTableShowFinishDate(tableEventDateCheckBox.isSelected());
        Config.setTableShowScroll(tableScrollCheckBox.isSelected());
    }    
    
    public void install(javax.swing.JPanel parent) {
        parent.add(this, java.awt.BorderLayout.CENTER);
    }    
    
    public void remove(javax.swing.JPanel parent) {
        parent.remove(this);
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox tableEventDateCheckBox;
    private javax.swing.JCheckBox tableEventTimeCheckBox;
    private javax.swing.JCheckBox tableScrollCheckBox;
    // End of variables declaration//GEN-END:variables
    
}
